"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.typeDefs = exports.typeDefsString = void 0;
const graphql_tag_1 = __importDefault(require("graphql-tag"));
const gists_1 = __importDefault(require("gists"));
const client_1 = require("@deep-foundation/hasura/client");
const client_2 = require("../client");
const packager_1 = require("../packager");
const apollo_server_express_1 = require("apollo-server-express");
const client_3 = require("../client");
const fs_1 = __importDefault(require("fs"));
const os_1 = __importDefault(require("os"));
const uuid_1 = require("uuid");
const child_process_1 = __importDefault(require("child_process"));
const semver = __importStar(require("semver"));
const apollo_server_core_1 = require("apollo-server-core");
const url_1 = __importDefault(require("url"));
const tmpdir = os_1.default.tmpdir();
const client = (0, client_1.generateApolloClient)({
    path: `${process.env.DEEPLINKS_HASURA_PATH}/v1/graphql`,
    ssl: !!+process.env.DEEPLINKS_HASURA_SSL,
    secret: process.env.DEEPLINKS_HASURA_SECRET,
});
const deep = new client_3.DeepClient({ apolloClient: client });
const packager = new packager_1.Packager(deep);
exports.typeDefsString = `
  type Query {
    packager_install(input: PackagerInstallInput): PackagerInstallOutput
    packager_publish(input: PackagerPublishInput): PackagerPublishOutput
  }
  input PackagerInstallInput {
    address: String
  }
  type PackagerInstallOutput {
    ids: [Int]
    errors: [String]
    packageId: Int
  }
  input PackagerPublishInput {
    id: Int
    address: String
  }
  type PackagerPublishOutput {
    ids: [Int]
    errors: [String]
  }
`;
exports.typeDefs = (0, graphql_tag_1.default) `${exports.typeDefsString}`;
const resolvers = {
    Query: {
        packager_install: (source, args, context, info) => __awaiter(void 0, void 0, void 0, function* () {
            var _a, _b, _c, _d;
            const errors = [];
            if (((_a = context === null || context === void 0 ? void 0 : context.headers) === null || _a === void 0 ? void 0 : _a['x-hasura-role']) !== 'admin' &&
                !(yield deep.can(yield deep.id('@deep-foundation/core', 'AllowPackagerInstall'), +((_b = context === null || context === void 0 ? void 0 : context.headers) === null || _b === void 0 ? void 0 : _b['x-hasura-user-id']), yield deep.id('@deep-foundation/core', 'AllowPackagerInstall')))) {
                errors.push('cant');
                return { errors };
            }
            const { address } = args.input;
            const uri = new url_1.default.URL(address);
            const isGist = uri.hostname === 'gist.github.com';
            const isNpm = uri.hostname === 'npmjs.com' || uri.hostname === 'www.npmjs.com';
            if (isGist) {
                const username = uri.username;
                const password = uri.password;
                const gistId = uri.pathname.split('/')[2];
                if (!username || !password) {
                    errors.push('gist requires user and pass');
                }
                if (!username || !password) {
                    errors.push('gist valid address like http://gist.github.com/account/gist');
                }
                if (errors.length)
                    return { errors };
                const gists = new gists_1.default({ username, password });
                const result = yield gists.get(gistId);
                const files = (_c = result === null || result === void 0 ? void 0 : result.body) === null || _c === void 0 ? void 0 : _c.files;
                const deepPckgContent = (_d = files === null || files === void 0 ? void 0 : files['deep.json']) === null || _d === void 0 ? void 0 : _d.content;
                if (deepPckgContent) {
                    try {
                        const deepPckg = JSON.parse(deepPckgContent);
                        const { ids, errors, packageId } = yield packager.import(deepPckg);
                        return { ids, errors, packageId };
                    }
                    catch (error) {
                        errors.push(error);
                    }
                }
                else {
                    errors.push(`deep.json not founded in gist`);
                }
            }
            else if (isNpm) {
            }
            else {
                errors.push(`address is not valid`);
            }
            return { ids: [], errors };
        }),
        packager_publish: (source, args, context, info) => __awaiter(void 0, void 0, void 0, function* () {
            var _e, _f;
            const errors = [];
            if (((_e = context === null || context === void 0 ? void 0 : context.headers) === null || _e === void 0 ? void 0 : _e['x-hasura-role']) !== 'admin' &&
                !(yield deep.can(yield deep.id('@deep-foundation/core', 'AllowPackagerPublish'), +((_f = context === null || context === void 0 ? void 0 : context.headers) === null || _f === void 0 ? void 0 : _f['x-hasura-user-id']), yield deep.id('@deep-foundation/core', 'AllowPackagerPublish')))) {
                errors.push('cant');
                return { errors };
            }
            const { id, address } = args.input;
            const uri = new url_1.default.URL(address);
            const isGist = uri.hostname === 'gist.github.com';
            const isNpm = uri.hostname === 'npmjs.com' || uri.hostname === 'www.npmjs.com';
            if (isGist) {
                const username = uri.username;
                const password = uri.password;
                const gistId = uri.pathname.split('/')[2];
                if (!username || !password) {
                    errors.push('gist requires user and pass');
                }
                if (!username || !password) {
                    errors.push('gist valid address like http://gist.github.com/account/gist');
                }
                if (errors.length)
                    return { errors };
            }
            else if (isNpm) {
                const dirid = (0, uuid_1.v4)();
                const dir = [tmpdir, dirid].join('/');
                const pckgDir = [tmpdir, dirid, 'node_modules', address].join('/');
                fs_1.default.mkdirSync(dir);
                try {
                    child_process_1.default.execSync(`cd ${dir}; npm install --no-cache ${address};`, { stdio: [0, 1, 2] });
                }
                catch (error) {
                    errors.push(error);
                    errors.push('installation failed');
                    return { errors };
                }
                const npmPckgPath = [pckgDir, 'package.json'].join('/');
                const npmPckgJSON = fs_1.default.readFileSync(npmPckgPath, { encoding: 'utf-8' });
                let npmPckg;
                let nextVersion;
                if (!npmPckgJSON) {
                    errors.push('package.json not founded in installed package');
                    return { errors };
                }
                else {
                    npmPckg = JSON.parse(npmPckgJSON);
                    npmPckg.version = nextVersion = semver.inc((npmPckg === null || npmPckg === void 0 ? void 0 : npmPckg.version) || '0.0.0', 'patch');
                }
                yield deep.update({
                    link: {
                        type_id: { _eq: client_2.GLOBAL_ID_PACKAGE_VERSION },
                        to_id: { _eq: id },
                    },
                }, { value: nextVersion }, { table: 'strings' });
                fs_1.default.writeFileSync(npmPckgPath, JSON.stringify(npmPckg), { encoding: 'utf-8' });
                const deepPckgContent = yield packager.export({ packageLinkId: id });
                fs_1.default.writeFileSync([pckgDir, 'deep.json'].join('/'), JSON.stringify(deepPckgContent), { encoding: 'utf-8' });
                child_process_1.default.execSync(`cd ${pckgDir}; npm publish;`, { stdio: [0, 1, 2] });
                fs_1.default.rmSync(dir, { recursive: true, force: true });
            }
            return { errors };
        }),
    }
};
const context = ({ req }) => {
    return { headers: req.headers };
};
const generateApolloServer = (httpServer) => {
    return new apollo_server_express_1.ApolloServer({
        introspection: true,
        typeDefs: exports.typeDefs,
        resolvers,
        context,
        plugins: [
            (0, apollo_server_core_1.ApolloServerPluginDrainHttpServer)({ httpServer }),
            (0, apollo_server_core_1.ApolloServerPluginLandingPageGraphQLPlayground)()
        ]
    });
};
exports.default = generateApolloServer;
//# sourceMappingURL=packager.js.map