export interface runnerControllerOptions {
    gqlURN: string;
    network: string;
    portsHash?: any;
    handlersHash?: any;
    docker: number;
}
export interface findPortOptions {
    handler: string;
    code: string;
    jwt: string;
    data: any;
    forceName?: string;
    forcePort?: number;
}
export interface initOptions {
    port: number;
}
export interface callOptions {
    code: string;
    jwt: string;
    data: any;
    port: number;
}
export declare const runnerControllerOptionsDefault: runnerControllerOptions;
export declare class RunnerController {
    gqlURN: string;
    network: string;
    docker: number;
    portsHash: {
        [id: number]: string;
    };
    handlersHash: {
        [id: string]: number;
    };
    constructor(options?: runnerControllerOptions);
    findPort(options: findPortOptions): Promise<{
        port?: number;
        error?: string;
    }>;
    initHandler(options: initOptions): Promise<{
        error?: string;
    }>;
    callHandler(options: callOptions): Promise<{
        error?: string;
    }>;
}
